﻿<%@ Page Language="vb" AutoEventWireup="false" CodeBehind="Default.aspx.vb" 
    Inherits="LinqListGridBind._Default" EnableEventValidation="true" EnableViewState="false" %>

<%@ Register Assembly="System.Web.Extensions, Version=3.5.0.0, Culture=neutral, PublicKeyToken=31bf3856ad364e35"
    Namespace="System.Web.UI" TagPrefix="ajax" %>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title>Using Linq to paginate your ObjectDataSource.</title>
    <style type="text/css">
        a:link {color: #000000;text-decoration: none;border-bottom: 1px dashed #d5ad84;}
        a:visited {color: #000000;text-decoration: none;border-bottom: 1px dashed #d5ad84;}
        a:hover {border-bottom: 1px solid #d5ad84;}
        a:active {color: #000000;text-decoration: none;border-bottom: 1px dashed #d5ad84;}
        h1 {font-size: 18px;font-weight: bold;color: #786652;}
        body {margin: 5px;font-family: Arial;font-size: 12px;}
        #xml{background-color: #fbedbb;border: 1px dotted #ff9900;width: 700px;padding: 3px;}
        #xml pre {margin-bottom:5px;margin-top:5px;}
    </style>
</head>
<body>
    <form id="form1" runat="server">
    <ajax:ScriptManager ID="PageScriptManager" runat="server" />
    <div>
        <h1>
        <a href="#Using+Linq+to+paginate+your+Object+DataSource+and+asp.net+c#+vb">
            Using Linq to paginate your ObjectDataSource.</a></h1>
        <ajax:UpdatePanel ID="ContentUpdatePanel" runat="server">
            <ContentTemplate>
                <div id="xml">
                    <strong>Vb.net</strong>
                    <pre>
'execute Linq query for result set
Dim result As IEnumerable(Of ZipCode) = (From zipcodes In ZipCodeInstance).Skip(<asp:Literal runat="server" ID="skip1" />).Take(<asp:Literal runat="server" ID="take1" />)
</pre>
                    <strong>C#</strong>
                    <pre>
//execute Linq query for result set
IEnumerable&lt;zipcode&gt; result = (from zipcodes in ZipCodeInstance select zipcodes).Skip(<asp:Literal runat="server" ID="skip2" />).Take(<asp:Literal runat="server" ID="take2" />);
</pre>
                </div>
                <br />
                <asp:Literal ID="statustop" runat="server"></asp:Literal>
                <br />
                <asp:GridView ID="ZipGrid" runat="server" AutoGenerateColumns="False" DataSourceID="ZipCodeObjectDataSource"
                    BackColor="LightGoldenrodYellow" BorderColor="Tan" BorderWidth="1px" CellPadding="2"
                    ForeColor="Black" GridLines="None" Width="100%">
                    <Columns>
                        <asp:BoundField DataField="Zip" HeaderText="Zip" ReadOnly="True" SortExpression="Zip"
                            HeaderStyle-HorizontalAlign="Left">
                            <HeaderStyle HorizontalAlign="Left" />
                        </asp:BoundField>
                        <asp:BoundField DataField="City" HeaderText="City" ReadOnly="True" SortExpression="City"
                            HeaderStyle-HorizontalAlign="Left">
                            <HeaderStyle HorizontalAlign="Left" />
                        </asp:BoundField>
                        <asp:BoundField DataField="State" HeaderText="State" ReadOnly="True" SortExpression="State"
                            HeaderStyle-HorizontalAlign="Left">
                            <HeaderStyle HorizontalAlign="Left" />
                        </asp:BoundField>
                        <asp:BoundField DataField="Latitude" HeaderText="Latitude" ReadOnly="True" SortExpression="Latitude"
                            HeaderStyle-HorizontalAlign="Left">
                            <HeaderStyle HorizontalAlign="Left" />
                        </asp:BoundField>
                        <asp:BoundField DataField="Longitude" HeaderText="Longitude" ReadOnly="True" SortExpression="Longitude"
                            HeaderStyle-HorizontalAlign="Left">
                            <HeaderStyle HorizontalAlign="Left" />
                        </asp:BoundField>
                        <asp:BoundField DataField="TimeZone" HeaderText="TimeZone" ReadOnly="True" SortExpression="TimeZone"
                            HeaderStyle-HorizontalAlign="Left">
                            <HeaderStyle HorizontalAlign="Left" />
                        </asp:BoundField>
                        <asp:BoundField DataField="Dst" HeaderText="Dst" ReadOnly="True" SortExpression="Dst" />
                    </Columns>
                    <FooterStyle BackColor="Tan" />
                    <SelectedRowStyle BackColor="DarkSlateBlue" ForeColor="GhostWhite" />
                    <PagerStyle BackColor="PaleGoldenrod" ForeColor="DarkSlateBlue" HorizontalAlign="Center" />
                    <HeaderStyle BackColor="Tan" Font-Bold="True" />
                    <AlternatingRowStyle BackColor="PaleGoldenrod" />
                </asp:GridView>
                <br />
                <asp:ObjectDataSource ID="ZipCodeObjectDataSource" runat="server" SelectMethod="GetZipCodes"
                    TypeName="LinqListGridBind.ZipCodeObjects.ZipCodeCollection">
                    <SelectParameters>
                        <asp:SessionParameter DefaultValue="20" Name="ResultsPerPage" SessionField="ResultsPerPage"
                            Type="Int32" />
                        <asp:SessionParameter DefaultValue="1" Name="PageNumber" SessionField="PageNumber"
                            Type="Int32" />
                    </SelectParameters>
                </asp:ObjectDataSource>
                <asp:LinkButton ID="prevClick" runat="server" Text="&lt;&lt; prev" />
                <asp:Literal ID="pagingseperator" runat="server" Visible="false">&nbsp;|&nbsp;</asp:Literal>
                <asp:LinkButton ID="nextClick" runat="server" Text="&gt;&gt; next" />
            </ContentTemplate>
        </ajax:UpdatePanel>
        <br />
        <br />
        <a href="http://www.aprogrammersjournal.com/"><span style="color: #000000">A Programmers
            Journal</span></a> | <a href="http://www.aprogrammersjournal.com/rss.aspx">
                <img alt="rss" src="http://www.aprogrammersjournal.com/images/rss.gif" style="clear: right;
                    border-top-style: none; border-right-style: none; border-left-style: none; border-bottom-style: none;
                    vertical-align: middle;" /></a>
    </div>
    </form>
</body>
</html>
